unit tw32ex4u;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls,MMSystem, Buttons,
  Grids, Calendar, DBGrids, DB, DBTables, Menus,
  WaveIn, WaveOut,Iofile, Tabnotbk;  {these 3 units belong to Twave}
type
  TMAIN = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    Table1Date: TDateField;   {key field}
    Table1Format: TBytesField; {waveform format information}
    Table1ACMFormat: TStringField;  {string representation of waveform format}
    Table1Audio: TBlobField;  {waveform data}
    DBGrid1: TDBGrid;
    OpenDialog1: TOpenDialog;
    tbActivationLevel: TTrackBar;
    tbSpeakerVol: TTrackBar;
    Clndr: TCalendar;
    cbMonth: TComboBox;
    eYear: TEdit;
    UpDown1: TUpDown;
    Shape1: TShape;
    btSetFormat: TButton;
    btRecord: TSpeedButton;
    btPause: TSpeedButton;
    btPlay: TSpeedButton;
    btDelete: TSpeedButton;
    btClear: TBitBtn;
    btClose: TBitBtn;
    btHelp: TBitBtn;
    log: TMemo;
    cbVoiceActivation: TCheckBox;
    Panel1: TPanel;
    paInfo: TPanel;
    paStatus: TPanel;
    paFormat: TPanel;
    Label3: TLabel;
    MainMenu1: TMainMenu;
    muAudio: TMenuItem;
    muSetWaveFormat: TMenuItem;
    muRecord: TMenuItem;
    muPause: TMenuItem;
    muPlay: TMenuItem;
    muDB: TMenuItem;
    muDelete: TMenuItem;
    muLoadFromFile: TMenuItem;
    N1: TMenuItem;
    N2: TMenuItem;
    muExit: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel6: TBevel;
    nbProperties: TTabbedNotebook;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    wiActivationLevel: TLabel;
    wiCurLevel: TLabel;
    wiAutoActivation: TLabel;
    wiBitsPerSample: TLabel;
    wiBlockAlign: TLabel;
    wiBlockSize: TLabel;
    wibytesPerSec: TLabel;
    wiCapacity: TLabel;
    wiChannels: TLabel;
    wiDeviceID: TLabel;
    wiSamplesPerSec: TLabel;
    GroupBox2: TGroupBox;
    Label20: TLabel;
    Label21: TLabel;
    Label23: TLabel;
    Label24: TLabel;
    Label25: TLabel;
    Label26: TLabel;
    Label27: TLabel;
    woBitsPerSample: TLabel;
    woBlockAlign: TLabel;
    woBytesPerSec: TLabel;
    woCapacity: TLabel;
    woChannels: TLabel;
    woDeviceID: TLabel;
    woSamplesPerSec: TLabel;
  {start-up}
    procedure FormCreate(Sender: TObject);
    procedure initDemoComponents(Sender: TObject);
    procedure initCalander(Sender: TObject);
    function setACMFormatString: string;

  {User controls for this demo:}
    procedure btSetFormatClick(Sender: TObject);
    procedure btRecordClick(Sender: TObject);
    procedure btPlayClick(Sender: TObject);
    procedure StopPlay(stMsg : string);
    procedure btClearClick(Sender: TObject);
    procedure btDeleteClick(Sender: TObject);
    procedure btPauseClick(Sender: TObject);

    procedure cbVoiceActivationClick(Sender: TObject);
    procedure tbSpeakerVolChange(Sender: TObject);
    procedure tbActivationLevelChange(Sender: TObject);
    procedure showcurLevel(Sender: TObject);
    procedure showProperties;

    procedure DBGrid1DblClick(Sender: TObject);
    procedure DBGrid1ColEnter(Sender: TObject);

    procedure cbMonthChange(Sender: TObject);
    procedure eYearChange(Sender: TObject);
    procedure ClndrChange(Sender: TObject);

    procedure Table1DateGetText(Sender: TField; var Text: string;
      DisplayText: Boolean);
    procedure muSetWaveFormatClick(Sender: TObject);
    procedure muRecordClick(Sender: TObject);
    procedure muPauseClick(Sender: TObject);
    procedure muPlayClick(Sender: TObject);
    procedure muDeleteClick(Sender: TObject);
    procedure muLoadFromFileClick(Sender: TObject);
    procedure paFormatClick(Sender: TObject);
    procedure muExitClick(Sender: TObject);
    procedure btHelpClick(Sender: TObject);

 {twave component events:}
    procedure WaveInput1Mute(Sender: TObject);
    procedure WaveInput1Overflow(Sender: TObject);
    procedure WaveInput1WaveInput(Sender: TObject);
    procedure WaveOutput1WaveOutput(Sender: TObject);
    procedure WaveOutput1End(Sender: TObject);

 {This, along with the waveevent procedures above,
   comprise the core of this demo}
    procedure makeRecord(table: TTable);       {open a DB record, create stream}
    procedure Loadfromfile(Sender: TObject);
    procedure getAudioFormat(table: TTable);
    procedure getAudioData(table: TTable);

  private
  public
    { Public declarations }
    WaveInput1: TWaveInput;
    WaveOutput1: TWaveOutput;
  end;

const ID : longint = 1;

var
  MAIN: TMAIN;
  BStream : TBlobStream;
  buffer : pointer;
  buffersize : longint;
  cursize : longint;

implementation

{$R *.DFM}

procedure TMAIN.FormCreate(Sender: TObject);
var i : integer;
begin
{create Twave components at runtime}
  initDemoComponents(Sender);
  setACMFormatString;
  showProperties;        {for demo}
  initCalander(Sender);

  {query the audio device for the current volume setting,
  set the slider control to this value}
   WaveOutput1.Open;
   tbSpeakerVol.Position:=integer(HiWord(WaveOutput1.GetVolume) div 655);
   WaveOutput1.Close;
end;

procedure TMAIN.initDemoComponents(Sender: TObject);
begin
(* waveInput1 and waveOutput1 create and initialization code
would not be required if the components were installed to the
Delphi VCL pallet.  The components are created here, in the
form create method, to make testing of these demo projects possible
without having first to install the components.*)
waveInput1 := TwaveInput.create(self);
with waveInput1 do begin
    DeviceID := -1;
    Capacity := 100;
    Asynchronous := False;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BlockAlign := 2;
    BitsPerSample := 16;
    AutoActivation := True;
    ActivationLevel := 3;
    preFrame := False;
    postFrame := 0;
    BlockSize := 12500;
    OnMute := WaveInput1Mute;
    OnOverflow := WaveInput1Overflow;
    OnWaveInput := WaveInput1WaveInput;
    Left := 80;
    Top := 72;
end;
waveOutput1 := TwaveOutput.create(self);
with waveOutput1 do begin
    DeviceID := -1;
    Capacity := 100;
    SamplesPerSec := 11025;
    BytesPerSec := 22050;
    Channels := 1;
    BitsPerSample := 16;
    OnEnd := WaveOutput1End;
    OnWaveOutput := WaveOutput1WaveOutput;
    Left := 80;
    Top := 72;
end;
end;

procedure TMAIN.initCalander(Sender: TObject);
var i : integer;
begin
   cbMonth.Items.Clear;
   for i:=1 to 12 do cbMonth.items.Add(LongMonthNames[i]);
   cbMonth.ItemIndex:=clndr.Month-1;
   eYear.text:=IntToStr(clndr.Year);
   ClndrChange(sender);
end;


function TMAIN.setACMFormatString: string;
var stFTag, stSps, stBps, stChannels : string[10];
begin
  with WaveOutput1 do begin
    if FWF.wFormatTag = 1 then
       stFTag := 'PCM ' else
       stFTag := '?';  {}

       case channels of
            1 : stChannels := 'Mono';
            2 : stChannels := 'Stereo';
            4 : stChannels := 'Quad';
            else stChannels := 'Error';
       end;
       stSps := IntToStr(SamplesPerSec)+' Hz, ';
       stBps := IntToStr(BitsPerSample)+' bits, ';
     result := stFTag+stSps+stBps+stChannels;
  end;
end;

procedure TMAIN.btSetFormatClick(Sender: TObject);
var wiError, woError : word;
    stWaveFormat : string;

begin
(*calling SelectFormat while recording or playing will result in
 a runtime error*)
   if (waveInput1.state = wisOpen) or
      (waveOutput1.state = wosOpen) then
    begin
      MessageDlg('Please stop record/play before making format change', mtInformation,
       [mbOk], 0);
      exit;
    end;
   waveInput1.clearRingBuffer;
 (*show the ACM format dialog, showing the wave formats installed
   on the current system; note, some formats shown may not be support
   by the installed audio device; see below for error checking*)
   stWaveFormat := WaveInput1.SelectFormat;
   if (stWaveFormat = 'Cancel') or (stWaveFormat = '') then exit;

   {display the selected format}
   paFormat.caption := stWaveFormat;

   {not all formats displayed by ACM are directly supported by ACM wave_mapper
   services, so we still need to test if we have a valid format for the system:}
      wiError:=WaveInput1.IsFormatSupported(WaveInput1.PFWF);
      woError:=WaveOutput1.IsFormatSupported(WaveOutput1.PFWF);
   {a returned value of 0 means that the format is supported}

      if ((wiError <> 0) or (woError <> 0)) then
         begin
           paInfo.caption := 'format not supported';
           btRecord.enabled := false;
           btPlay.enabled := false;
         end else
         begin
           paInfo.caption := 'format supported';
           btRecord.enabled := true;
           btPlay.enabled := true;
         end;
end;

procedure TMAIN.btRecordClick(Sender: TObject);
begin
   if btPause.down then btPause.down := false;

   if btRecord.Down then begin
      makeRecord(table1); {record opened, stream created}

      {turn output off - of course nothing happens if playing is not current}
      {if the installed wave device is full duplex, then this would not be *required*}
      btPlay.Down:=false;
      WaveOutput1.Stop;
      WaveOutput1.Close;

      paStatus.caption := 'Recording';
      WaveInput1.Open;
      WaveInput1.Start;

   end else begin  {Record button is going from down to up position}
      paStatus.caption := 'Recording stopped';
      tbActivationLevel.SelEnd:=0;    {reset the voice-level indication}
      WaveInput1.Stop;                {stop recording}
      WaveInput1.Close;
      BStream.Free;                   {release the stream}
      Table1.Post;                    {post the record}
   end;
end;

procedure TMAIN.btPlayClick(Sender: TObject);
begin
   if btPause.down then btPause.down := false;
   If table1.recordCount = 0 then begin
      btPlay.down := false;
      exit;
   end;
   if not btPlay.Down then
      StopPlay('play stopped') else  {btPlay toggled from down to up}
   begin
      paStatus.caption := 'Playing';
      if waveInput1.state = wisOpen then begin
         btRecord.down:=false;
         btRecordClick(Sender); {run record-stop code}
      end;

      getAudioFormat(table1); {determine format of stored audio,}
                              {and set waveOutput to support conversion}
      getAudioData(table1);  {read the data (if any) from the current db record}
      showProperties;

      if WaveOutput1.MessageCount > 0 then
         begin
           Clndr.Enabled:=false;
           DBGrid1.Enabled:=false;
           WaveOutput1.PlayBuffer;
           WaveOutput1.PlayBuffer;
           {playing the buffer will result in a WaveOutput event, where
            you playbuffer will be called again, and thus repeated until the
            waveOutput buffer is empty}
         end else
            StopPlay('no audio data'); {btPlay toggled down, but no content to play}
  end;
end;

procedure TMAIN.StopPlay(stMsg : string);
begin
  {stop playing}
  WaveOutput1.Stop;
  WaveOutput1.Close;
  {clean up}
  Waveoutput1.ClearRingBuffer;
  BStream.Free;
  FreeMem(buffer,buffersize);
  {refresh the UI}
  paStatus.caption := stMsg;
  btPlay.down := false;
  btPause.down := false;
  Clndr.Enabled:=true;
  DBGrid1.Enabled:=true;
end;

procedure TMAIN.btClearClick(Sender: TObject);
begin
log.clear;
end;


procedure TMAIN.btPauseClick(Sender: TObject);
begin
  if btPause.down then
    begin
       if btRecord.down then
          begin
          paStatus.caption := 'Recording paused';
          tbActivationLevel.SelEnd:=0;
          waveInput1.stop;
          waveInput1.close;
          end else
          if btPlay.down then
             begin
             paStatus.caption := 'Playing paused';
             waveOutput1.pause
             end else
               btPause.down := false;
    end else
    begin
       if btRecord.down then
          begin
          paStatus.caption := 'Recording resumed';
          waveInput1.open;
          waveInput1.start;
          end else
          if btPlay.down then
             begin
             paStatus.caption := 'Playing Resumed';
             waveOutput1.resume
             end else
               btPause.down := false;
    end;
end;

(*The acm format string is set when you call SetFormat;
 (when you click on the [Set Wave Format button] in this project)
 However, if the user begins recording using the default waveInput properties,
 then the format string is not initialized, so here we build it.   None of this
 code is very important in any event. *)

procedure TMAIN.btDeleteClick(Sender: TObject);
begin
  if (waveInput1.state = wisOpen) or
     (waveOutput1.state = wosOpen) then
      MessageDlg('End record or play before deleting a record', mtInformation,
      [mbOk], 0) else

      begin
        Table1.Delete;
        paStatus.caption := 'Record deleted';
      end;
end;

procedure TMAIN.btHelpClick(Sender: TObject);
begin
  application.helpJump('');
end;

procedure TMAIN.tbSpeakerVolChange(Sender: TObject);
var W : Word;
begin
    W:=tbSpeakerVol.Position*655;
    WaveOutput1.SetVolume(W,W);
end;

procedure TMAIN.cbVoiceActivationClick(Sender: TObject);
begin
  waveInput1.autoActivation := cbVoiceActivation.checked;
  showProperties;
  if not waveInput1.autoActivation then
  begin
    tbActivationLevel.selEnd := 0;
    tbActivationLevel.position := 0;
    wiActivationLevel.Caption:='0';
  end;
end;

procedure TMAIN.tbActivationLevelChange(Sender: TObject);
begin
   if waveInput1.autoActivation then begin
     waveInput1.ActivationLevel:=(tbActivationLevel.Position) * 100;
     wiActivationLevel.Caption:=IntToStr(waveInput1.ActivationLevel div 100);
   end else
   tbActivationLevel.position := 0;
end;

procedure TMAIN.showcurLevel(Sender: TObject);
begin
   tbActivationLevel.SelEnd:=(WaveInput1.CurLevel div 100 );
   wiCurLevel.Caption:=intToStr(WaveInput1.CurLevel div 100);
end;

procedure TMAIN.showProperties;
{all of the design time properties are shown for the demo;
 see the help file for run-time only properties}
begin
{WaveInput properties}
  if waveInput1.AutoActivation then
     wiActivationLevel.caption := intToStr(waveInput1.ActivationLevel) else
     wiActivationLevel.caption := '0';
  wiBitsPerSample.caption := intToStr(waveInput1.bitsPerSample);
  wiBlockAlign.caption := intToStr(waveInput1.BlockAlign);
  wiBlockSize.caption := intToStr(waveInput1.BlockSize);
  wiBytesPerSec.caption := intToStr(waveInput1.BytesPerSec);
  wiCapacity.caption := intToStr(waveInput1.Capacity);
  wiChannels.caption := intToStr(waveInput1.Channels);
  wiDeviceID.caption := intToStr(waveInput1.DeviceID);
  wiSamplesPerSec.caption := intToStr(waveInput1.SamplesPerSec);
  wicurLevel.caption := intToStr(waveInput1.curLevel);
  if waveInput1.autoActivation then wiautoActivation.caption := 'true' else
     wiautoActivation.caption := 'false';

{WaveOutput properties}
  woBitsPerSample.caption := intToStr(waveOutput1.bitsPerSample);
  woBlockAlign.caption := intToStr(waveOutput1.BlockAlign);
  woBytesPerSec.caption := intToStr(waveOutput1.BytesPerSec);
  woCapacity.caption := intToStr(waveOutput1.Capacity);
  woChannels.caption := intToStr(waveOutput1.Channels);
  woDeviceID.caption := intToStr(waveOutput1.DeviceID);
  woSamplesPerSec.caption := intToStr(waveOutput1.SamplesPerSec);
end;

procedure TMAIN.DBGrid1DblClick(Sender: TObject);
begin
  if Sender=Clndr then
  if not Table1.FindKey([Clndr.CalendarDate]) then exit;
  btPlay.Down:=true;
  btPlayClick(Sender);
end;

procedure TMAIN.DBGrid1ColEnter(Sender: TObject);
begin
  if not Table1.FindKey([Clndr.CalendarDate]) then exit;
  btPlay.Down:=true;
  btPlayClick(Sender);
end;

procedure TMAIN.cbMonthChange(Sender: TObject);
begin
   clndr.Month:=cbMonth.ItemIndex+1;
end;

procedure TMAIN.eYearChange(Sender: TObject);
begin
   clndr.Year:=StrToInt(eYear.text);
end;

procedure TMAIN.ClndrChange(Sender: TObject);
begin
if Table1.FindKey([Clndr.CalendarDate]) then
  btPlay.Enabled:=true else
  btPlay.Enabled:=false
end;

procedure TMAIN.muSetWaveFormatClick(Sender: TObject);
begin
  btSetFormatClick(self);
end;

procedure TMAIN.muRecordClick(Sender: TObject);
begin
  btRecord.down := not btRecord.down;
  btRecordClick(Self);
end;

procedure TMAIN.muPauseClick(Sender: TObject);
begin
  btPause.down := not btPause.down;
  btPauseClick(Self);
end;

procedure TMAIN.muPlayClick(Sender: TObject);
begin
  btPlay.down := not btPlay.down;
  btPlayClick(Sender);
end;

procedure TMAIN.muDeleteClick(Sender: TObject);
begin
  btDeleteClick(Self);
end;

procedure TMAIN.muLoadFromFileClick(Sender: TObject);
begin
  Loadfromfile(self);
end;

procedure TMAIN.muExitClick(Sender: TObject);
begin
  close;
end;

procedure TMAIN.paFormatClick(Sender: TObject);
begin
  btSetFormatClick(Self);
end;

procedure TMAIN.Table1DateGetText(Sender: TField; var Text: string;
  DisplayText: Boolean);
begin
  btPlay.Enabled:=true;
  DisplayText:=true;
  Text:=FormatDateTime('mm/dd/yy',(sender as TDateField).Value);
end;

procedure TMAIN.WaveInput1Mute(Sender: TObject);
begin
   log.lines.add('waveIn mute');
   showcurLevel(self);
end;

procedure TMAIN.WaveInput1Overflow(Sender: TObject);
begin
 if waveInput1.autoActivation then  {show current mic input level}
   tbActivationLevel.SelEnd:=WaveInput1.CurLevel div 10;
   log.lines.add('waveIn buffer overflow');
end;

procedure TMAIN.WaveInput1WaveInput(Sender: TObject);
var WE : TWaveEvent;
begin
   log.lines.add('WaveInput');
   showcurLevel(self);
   (*take the current wave event from the input buffer,
     and write it to the stream*)
   WE:=WaveInput1.GetWaveEvent;
   if WE=nil then exit;
   if (WE.BufData<>nil) and (WE.BufSize>0) then begin
     BStream.Write(WE.Bufdata^,WE.BufSize);
     WE.Free;
   end
   else WE.Free;
end;

procedure TMAIN.WaveOutput1WaveOutput(Sender: TObject);
begin
   log.lines.add('WaveOutput');
   WaveOutput1.PlayBuffer;   {play the next buffer, if there is one.}
   WaveOutput1.PlayBuffer;
   cursize:=BStream.Read(buffer^,buffersize);  {see if there's more data in the stream}
   if cursize<>0 then  begin                   {if there is, then add it to the output buffer}
      WaveOutput1.AddBlock(buffer,cursize,ID); {so it will be available to be played on the }
      Inc(ID);                                 {next WaveOutput event }
   end;
end;

procedure TMAIN.WaveOutput1End(Sender: TObject);
begin
   log.lines.add('WaveOut-OnEnd');
   paStatus.caption := 'All done!';
   btPlay.Down:=false;
   btPlayClick(Sender);
end;

procedure TMAIN.makeRecord(table: TTable);
begin
    if table1.FindKey([Clndr.CalendarDate]) then table1.Delete;
    table1.Append;
    table1['Date'] :=Clndr.CalendarDate;
    table1.FieldByName('Format').SetData(WaveInput1.PFWF);
    table1.FieldByName('ACMFormat').value:=waveInput1.ACMFormat;
    BStream:=TBlobStream.Create((table1.FieldByName('Audio') as TBlobField),bmWrite);
end;

{this procedure isolates some of the code that may seem a bit more
 intimidating;  you may be able to use this code as-is, *if* the table
 referenced has the indicated field names; otherwise, make changes as required }
procedure TMAIN.getAudioFormat(table: TTable);
begin
  with table do begin
    if  WaveOutput1.sizeFWF<>0 then FreeMem(WaveOutput1.PFWF, WaveOutput1.sizeFWF);
    GetMem(WaveOutput1.PFWF,FieldByName('Format').DataSize);
    FieldByName('Format').GetData(WaveOutput1.PFWF);
    WaveOutput1.sizeFWF:=FieldByName('Format').DataSize;
    Waveoutput1.FWF := waveOutput1.PFWF^;

    paFormat.caption:=FieldByName('ACMFormat').asString;
  end;
end;

procedure TMAIN.getAudioData(table: TTable);
begin
   WaveOutput1.Open;
   {set the buffersize to equal wave block size}
   if WaveOutput1.BlockAlign>4 then
        buffersize:=WaveOutput1.PFWF^.nBlockAlign * 5
   else buffersize:=WaveOutput1.BlockAlign*9096;

   {allocate memory for the buffer, create the stream}
   GetMem(buffer,buffersize);
   BStream:=TBlobStream.Create((Table.FieldByName('Audio') as TBlobField),bmRead);

   ID:=1;  {output buffer starting position}
   {load the output buffer from the stream}
   repeat
     cursize:=BStream.Read(buffer^,buffersize);
     WaveOutput1.AddBlock(buffer,cursize,ID);
     Inc(ID);
   until (cursize=0) or (WaveOutput1.MessageCount=WaveOutput1.Capacity);
end;

procedure TMAIN.Loadfromfile(Sender: TObject);
var size : longint;
    buf : array[0..1023] of byte;
begin
  if not OpenDialog1.Execute then exit;
  if Table1.FindKey([Clndr.CalendarDate]) then Table1.Delete;
  size:=OpenWaveFile( OpenDialog1.FileName,
                      WaveOutput1.PFWF,
                      WaveOutput1.sizeFWF);

  Table1.Append;
  Table1['Date'] :=Clndr.CalendarDate;
  Table1.FieldByName('Format').SetData(WaveOutput1.PFWF);
  BStream:=TBlobStream.Create((Table1.FieldByName('Audio') as TBlobField),bmWrite);
  repeat
  cursize:=readWaveBlock(@buf,sizeof(buf));
  BStream.Write(Buf,curSize);
  until cursize<sizeof(buf);
  CloseWaveFile;
  BStream.Free;
end;


end.
